

//#include <Servo.h>
#include <VarSpeedServo.h>

//Servo myservo;  // create servo object to control a servo
VarSpeedServo myservo;

int pot = 0;  // analog pin used to connect the potentiometer
float theta_L;    
int theta_L_map;
int theta_M;   
int theta_M_servo;
int button = 'o';
int ref = 0;
int delta = 1;
int ref_new = 0;
boolean pressed = false;
int dtime = 30;
int Kp = 1;
int error = 0;


void setup() {
  // put your setup code here, to run once:
  myservo.attach(9);  // attaches the servo on pin 9 to the servo object
  pinMode(7, OUTPUT); //up button
  pinMode(6, OUTPUT); //down button
  pinMode(5, OUTPUT); //ref step 1
  pinMode(4, OUTPUT); //ref step 2
  pinMode(3, OUTPUT); //ref step 3
  Serial.begin(9600);

}

void loop() {
  // put your main code here, to run repeatedly:

  if(Serial.available()>0){ // lee el bluetooth y almacena en estado
  button = Serial.read();
  }
  if(button=='s'){ // comienza el servo en 0 grados, aka 90
  myservo.write(90,20,true);
  //delay(15);
  ref_new = 0;
  pressed = true;
  }
//  else if(button=='1'){ // delta de ref es 1
//  digitalWrite(5,HIGH);
//  delay(15);
//  digitalWrite(5,LOW);
//  delta = 1;
//  pressed = true;
//  dtime = 30;
//  }
  else if(button=='2'){
  digitalWrite(4,HIGH);
  delay(15);
  digitalWrite(4,LOW);
  delta = 5;
  pressed = true;
  dtime = 150; //30*5
  }
  else if(button=='3'){
  digitalWrite(3,HIGH);
  delay(15);
  digitalWrite(3,LOW);
  delta = 15;
  pressed = true;
  dtime = 210;//30*7
  }
  else if(button=='t' and pressed==false){ // ir a top 45
  ref_new = 45;
  pressed = true;
  }
  else if(button=='b' and pressed==false){ // ir a bottom -45
  ref_new = -45;
  pressed = true;
  }
  else if(button=='u' and pressed==false){ // Subir referencia
  digitalWrite(7,HIGH);
  delay(15);
  digitalWrite(7,LOW);
  ref_new = ref + delta;
  pressed = true;
  }
  else if(button=='d' and pressed==false){ // Bajar referencia
  digitalWrite(6,HIGH);
  delay(15);
  digitalWrite(6,LOW);
  ref_new = ref - delta;
  pressed = true;
  }
  else if(button=='p'){ // parar referencia
  delay(15);
  pressed = false;
  }
  
  Serial.flush();
  
  theta_L = analogRead(pot);                      // reads the value of the potentiometer (value between 0 and 1023)
  theta_L_map = map(theta_L, 90, 860, -90, 90);   // scale it to use it with the servo (value between 0 and 180)

  if(ref_new > 90){
    ref_new = 90;
  }
  else if(ref_new < -90){
    ref_new = -90;
  }

  if( pressed == true ){
  theta_M = ref_new; //control directo de referencia igual al servo
  //error = ref_new - theta_L_map;
  //theta_M = Kp * error;
  }
  //aca se puede agregar que si va muy rapido se hacen dos iteraciones
  // asi se disminuye la velocidad, o se usa la lib de speed
  
  theta_M_servo = map(theta_M, -90, 90, 0, 180);

  if (theta_M_servo > 180){
    theta_M_servo = 180;
  }
  else if (theta_M_servo < 0){
    theta_M_servo = 0;
  }
   
  myservo.write(theta_M_servo,10,true);
  //delay(dtime);           
  
  Serial.print("Theta L: "); 
  Serial.print("\t"); 
  Serial.print(theta_L);
  Serial.print("\t"); 
  Serial.print("Theta L Map: "); 
  Serial.print("\t"); 
  Serial.print(theta_L_map);
  Serial.print("\t"); 
  Serial.print("Ref: "); 
  Serial.print("\t"); 
  Serial.print(ref_new);
  Serial.print("\t"); 
//  Serial.print("Error: "); 
//  Serial.print("\t"); 
//  Serial.print(error);
//  Serial.print("\t"); 
  Serial.print("Theta Servo: "); 
  Serial.print("\t"); 
  Serial.print(theta_M_servo);
  Serial.println("");

  ref = ref_new;
  

}
