%Modelacion, asumiendo sistema en equilibrio...

clc
clear all
close all

M = 5; %kg
g = 9.8;
L = 0.3; %m
%w=0.050;
%b=0.010;

k = 0.3*1000;

rl = (25.4/2)/1000; %m
rm = (25.4/2)/1000; %m
Jl = (1/3)*M*L^2;

%Free Length (L)30.00 mm
%Max. Extension (mm)37.99 mm
dL = (37.99 - 30)/1000;
dtheta_max = dL/rl;

%Definimos la ecuacion del sistema X_punto = f(x,u)
% x1 = theta_L
% x2 = theta_L_punto = omega_L
% u  = theta_M
%syms x1
%syms x2
%syms u

%F = [ x2 ; 
%    (1/Jl)*2*k*rl*(rl*x1-rm*u) ];

dt = 0.01;
t = dt:dt:100;

%% Partamos por lo basico, una simulacion, de escalon, con pid
Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(L/10:L) = 30*pi/180; %30 grados en escalon

for i=2:L
   
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
    %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max/2;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max/2;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Actualizacion de error
    error_p = error;
    
end

figure(1)
set(gcf,'Color',[1,1,1])
set(gca,'FontSize',14)
suptitle('Escalon, sistema en torno a 0')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref','Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M','Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error','Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M','Location','best')
%xlabel('Angulo [ ]')

%% Sistema en torno a 90

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = pi/2;
x2_0 = 0;
u_0  = pi/2;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

ref = zeros(1,L);
ref(:) = pi/2; 
ref(L/10:L) = pi/2+30*pi/180; %10 grados en escalon

for i=2:L
   
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < 0
        U(i) = 0;
    end
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Actualizacion de error
    error_p = error;
    
end

figure(2)
set(gcf,'Color',[1,1,1])
subplot(2,1,1)
plot(t,rad2deg(X(1,:)),t,rad2deg(ref),'r','Linewidth',1.5)
title('Escalon, sistema en torno a 90')
legendInfo{1} = ['Theta_L']; 
legendInfo{2} = ['Ref']; 
legend(legendInfo)%,'Location','southeastinside')
subplot(2,1,2)
plot(t,rad2deg(U),'g','Linewidth',1.5)
legendInfo{1} = ['Theta_M']; 
xlabel('Angulo [ ]')
legend(legendInfo)

%Por alguna razon se cae al principio y no entiendo porque... 
%Asumamos que el sistema esta en pi/2 pero en torno a 0...

%% Sinusoide...

Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(629:L) = sin(0.5*t(629:L))*10*pi/180; 

for i=2:L
   
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Actualizacion de error
    error_p = error;
    
end

%plot(t,X(2,:))

figure(3)
set(gcf,'Color',[1,1,1])
suptitle('Sinusoide, sistema en torno a 0')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref','Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M','Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error','Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M','Location','best')
%xlabel('Angulo [ ]')

figure(7)
set(gcf,'Color',[1,1,1])
set(gca,'FontSize',14)
%suptitle('Sinusoide con obstculo')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-20 20])
box on
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('\theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-30 20])
%xlabel('Angulo [ ]','FontSize', 16)
legend('\theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
%ylim([-40 40])
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
%ylim([-40 40])
legend('\theta_L - \theta_M')%,'Location','best')
xlabel('Angle [ ]')
ylabel('Time [s]')
%[ax1,h1]=suplabel('Time [s]');
%[ax2,h2]=suplabel('Angle [ ]','y');
set(h1,'FontSize',14)
set(h2,'FontSize',14)
print -depsc


%% Sinusoide... con restriccion de angulos

Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(L/10:L) = sin(0.5*t(L/10:L))*10*pi/180; %10 grados en escalon
%para referencia bonita 629
%Agregar perturbacion a la referencia
%ref(L/2:L/2+L/5) = -10*pi/180;
j = 0;

for i=2:L
 
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
        %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max/2;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max/2;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Perturbacion a la medicion del estado, fijo en posicin
    if  i > 19.9/dt && i < 37.89/dt
        X(1,i) = -5*pi/180;
        X(2,i) = 0;
    end
    
    %Actualizacion de error
    error_p = error;
    

end

display(k,'Numero de restricciones de angulo')
%plot(t,X(2,:))

figure(4)
set(gcf,'Color',[1,1,1])
suptitle('Sinusoide, sistema en torno a 0, angulo restringido')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M')%,'Location','best')
%xlabel('Angulo [ ]')

%plot(t,rad2deg(error_i),'cyan','Linewidth',1.5)



%% Sinusoide mas lenta pero alta... con restriccion de angulos %ploteado

Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(12.56/dt:L) = sin(0.25*t(12.56/dt:L))*30*pi/180; %10 grados en escalon
%Agregar perturbacion a la referencia
%ref(L/2:L/2+L/5) = -10*pi/180;
j = 0;

for i=2:L
 
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
        %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Perturbacion a la medicion del estado, fijo en posicin
    if  i > 38.5/dt && i < 53/dt
        X(1,i) = -5*pi/180;
        X(2,i) = 0;
    end
    
    %Actualizacion de error
    error_p = error;
    

end

display(k,'Numero de restricciones de angulo')
%plot(t,X(2,:))

figure(5)
set(gcf,'Color',[1,1,1])
set(gca,'FontSize',14)
%suptitle('Sinusoide con obstculo')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-60 60])
box on
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('\theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-60 60])
%xlabel('Angulo [ ]','FontSize', 16)
legend('\theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-60 60])
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
xlabel('Angle [ ]')
ylabel('Time [s]')
ylim([-60 60])
legend('\theta_L - \theta_M')%,'Location','best')
%xlabel('Angulo [ ]')
%[ax1,h1]=suplabel('Time [s]');
%[ax2,h2]=suplabel('Angle [ ]','y');
set(h1,'FontSize',14)
set(h2,'FontSize',14)
print -depsc

%plot(t,rad2deg(error_i),'cyan','Linewidth',1.5)


%% Sinusoide mas lenta pero alta... con restriccion de angulos
% y si cambiamos los R?

Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

dtheta_max = dL/(2*rl);

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(12.56/dt:L) = sin(0.25*t(12.56/dt:L))*30*pi/180; %10 grados en escalon
%Agregar perturbacion a la referencia
%ref(L/2:L/2+L/5) = -10*pi/180;
j = 0;

for i=2:L
 
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
        %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*2*rl*(2*rl*X(1,i-1)-2*rm*U(i)) ].*dt;
    
    %Perturbacion a la medicion del estado, fijo en posicin
    if  i > 38.5/dt && i < 53/dt
        X(1,i) = -5*pi/180;
        X(2,i) = 0;
    end
    
    %Actualizacion de error
    error_p = error;
    

end

display(k,'Numero de restricciones de angulo')
%plot(t,X(2,:))

figure(5)
set(gcf,'Color',[1,1,1])
suptitle('Sinusoide, sistema en torno a 0, angulo restringido, R = 2in')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M')%,'Location','best')
%xlabel('Angulo [ ]')

%plot(t,rad2deg(error_i),'cyan','Linewidth',1.5)


%% rampa?... con restriccion de angulos

dt = 0.01;
t = dt:dt:100;

Kp = 12;
Ki = 10.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = zeros(size(t));
error_i = zeros(size(t));
error_d = zeros(size(t));
%error_p = 0;
N = 20;

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(10/dt:30/dt) = 0:(30*pi/180)/(20/dt):30*pi/180; %10 grados en escalon
ref(30/dt:L) = 30*pi/180;
%para referencia bonita 629
%Agregar perturbacion a la referencia
%ref(L/2:L/2+L/5) = -10*pi/180;
j = 0;

for i=2:L
   
%     error = ref(i) - X(1,i-1);
%     if(abs(error) > dtheta_max/5)
%        ref(i) = (X(1,i-1)+ref(i-1))/2 ; %Promedio
%        error = ref(i) - X(1,i-1); %Lo calcula de nuevo
%     end
    
    %Calculo de errores
    error(i) = ref(i) - X(1,i-1);
    error_i(i) = error_i(i) + error(i)*dt;
    error_d(i) = (error(i)-error(i-1))/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error(i) + Ki*error_i(i) + Kd*error_d(i);
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
    %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max/2;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max/2;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*rl*(rl*X(1,i-1)-rm*U(i)) ].*dt;
    
    %Perturbacion a la medicion del estado, fijo en posicin
%     if  i > 19.9/dt && i < 37.89/dt
%         X(1,i) = -5*pi/180;
%         X(2,i) = 0;
%     end
    
    %Si la perturbacin es mucha, debera actualizarse la referencia para
    %que vuelva gradualmente y no drasticamente a esta el sistema
%     if(abs(error) > dtheta_max/2)
%        ref(i+1) = (X(1,i)+ref(i))/2 ; %Promedio
%     end
    
    %Actualizacion de error
    %error_p = error;
    
end

display(k,'Numero de restricciones de angulo')
%plot(t,X(2,:))

figure(6)
set(gcf,'Color',[1,1,1])
suptitle('Escalon, sistema en torno a 0')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M')%,'Location','best')
%xlabel('Angulo [ ]')
%%
figure
plot(t,rad2deg(error_i),'cyan','Linewidth',1.5)
figure
plot(t,rad2deg(error_d),'cyan','Linewidth',1.5)


%% Ahora quiero agregar que los resortes no partan en su largo natural...

% .....not yet

%Free Length (L)30.00 mm
%Max. Extension (mm)37.99 mm
dL = (37.99 - 30)/1000;
dtheta_max = dL/rl;

%Definimos la ecuacion del sistema X_punto = f(x,u)
% x1 = theta_L
% x2 = theta_L_punto = omega_L
% u  = theta_M
%syms x1
%syms x2
%syms u

%F = [ x2 ; 
%    (1/Jl)*2*k*rl*(rl*x1-rm*u) ];


Kp = 12;
Ki = 0.9;
Kd = 5;

X = zeros(2,size(t,2));
L = size(t,2);

x1_0 = 0;
x2_0 = 0;
u_0  = 0;

X(:,1) = [x1_0;x2_0];
U = zeros(1,L);
U(1) = u_0;
u_lim = pi/2;
error = 0;
error_i = 0;
error_d = 0;
error_p = 0;
N = 20;

dtheta_max = dL/(2*rl);

ref = zeros(1,L);
%ref(:) = pi/2+dt; 
ref(12.56/dt:L) = sin(0.25*t(12.56/dt:L))*30*pi/180; %10 grados en escalon
%Agregar perturbacion a la referencia
%ref(L/2:L/2+L/5) = -10*pi/180;
j = 0;

for i=2:L
 
    %Calculo de errores
    error = ref(i) - X(1,i-1);
    error_i = error_i + error*dt;
    error_d = (error-error_p)/dt;%*N/(1+N*dt)*;
    %Calculo variable manipulada
    U(i) = Kp*error + Ki*error_i + Kd*error_d;
    %Saturacion
    if U(i) > u_lim
        U(i) = u_lim;
    elseif U(i) < -u_lim
        U(i) = -u_lim;
    end
    
        %Restriccion de angulos
    if X(1,i-1)-U(i) > dtheta_max/2
        U(i) = X(1,i-1)-dtheta_max;
        %display(rad2deg(X(1,i-1)-U(i)),'Atraso')
        %display(t(i),'t')
        j = j + 1;
    elseif U(i)-X(1,i-1) > dtheta_max/2
        U(i) = X(1,i-1)+dtheta_max;
        %display(rad2deg(-X(1,i-1)+U(i)),'Adelanto')
        %display(t(i),'t')
        j = j + 1;
    end
    
    
    %Transicion de estados
    % X = X(i-1) + F(X(i-1),u(i))*dt
    X(:,i) = X(:,i-1) + [ X(2,i-1) ;-(1/Jl)*2*k*2*rl*(2*rl*X(1,i-1)-2*rm*U(i)) ].*dt;
    
    %Perturbacion a la medicion del estado, fijo en posicin
    if  i > 38.5/dt && i < 53/dt
        X(1,i) = -5*pi/180;
        X(2,i) = 0;
    end
    
    %Actualizacion de error
    error_p = error;
    

end

display(k,'Numero de restricciones de angulo')
%plot(t,X(2,:))

figure(5)
set(gcf,'Color',[1,1,1])
suptitle('Sinusoide, sistema en torno a 0, angulo restringido, R = 2in')
subplot(2,2,1)
hold on
plot(t,rad2deg(X(1,:)),'b','Linewidth',1.5)
plot(t,rad2deg(ref),'r','Linewidth',1.5)
%legendInfo{1} = ['Theta_L']; 
%legendInfo{2} = ['Ref']; 
legend('Theta_L','Ref')%,'Location','best')%,'Location','southeastinside')
hold off
subplot(2,2,3)
plot(t,rad2deg(U),'g','Linewidth',1.5)
xlabel('Angulo [ ]')
legend('Theta_M')%,'Location','best')
subplot(2,2,2)
plot(t,rad2deg(ref-X(1,:)),'magenta','Linewidth',1.5)
legend('Error')%,'Location','best')
subplot(2,2,4)
plot(t,rad2deg(X(1,:)-U),'cyan','Linewidth',1.5)
legend('Theta_L - Theta_M')%,'Location','best')
%xlabel('Angulo [ ]')

%plot(t,rad2deg(error_i),'cyan','Linewidth',1.5)






















